
#include "config.h"

int counter1_target = 0;
int counter2_target = 0;

void setup() {
  Serial.begin(115200);
  while (!Serial);
  Serial.println("Crustom CNC by skmskm");
  pinMode(driver_X::DIRECTION, OUTPUT);
  pinMode(driver_Z::DIRECTION, OUTPUT);
  pinMode(driver_X::STEP, OUTPUT);
  pinMode(driver_Z::STEP, OUTPUT);
  pinMode(spindle::INDEX, INPUT);
  pinMode(spindle::SYNC, INPUT);
  cli();
  TCCR1A = 0;//X
  TCCR1B = 0;
  TCCR2A = 0;//Z
  TCCR2B = 0;
  sei();
  
}

float GetFloat(String str,int &pos);
//actual pos;
float pos_X = 0;
float pos_Z = 0;
float speed_F = 500;

void loop()
{
  
}

void serialEvent(){
  {
    String line=Serial.readString();
    unsigned int len = line.length();
    if( len < 2 )
      return;
    if( ( line.charAt(0) == 'G' ) || ( line.charAt(0) == 'g' ) )
    {
      int pos = 1;
      float Gcode_num = GetFloat(line,pos);
      float Xvalue = pos_X;
      float Zvalue = pos_Z;
      float Fvalue = speed_F;
      float Kvalue = 0;//G33
      int limit = 4;//max 4 passes more means errors
      while( ( pos < len ) && ( limit != 0 ) )
      {
        if( ( line.charAt(pos) == 'X' ) || ( line.charAt(pos) == 'x' ) )
          Xvalue = GetFloat(line,++pos);
        if( ( line.charAt(pos) == 'Z' ) || ( line.charAt(pos) == 'z' ) )
          Zvalue = GetFloat(line,++pos);
        if( ( line.charAt(pos) == 'K' ) || ( line.charAt(pos) == 'k' ) )
          Kvalue = GetFloat(line,++pos);
        if( ( line.charAt(pos) == 'F' ) || ( line.charAt(pos) == 'f' ) )
          Fvalue = GetFloat(line,++pos);
        limit--;
      }
      speed_F = Fvalue;
      //do Gcode
      if( Gcode_num == 92 )//G92 zero axis XZ
      {
        pos_X = Xvalue;
        pos_Z = Zvalue;
        Serial.print(" ok");
      }
      if( Gcode_num == 33 )//G92 zero axis XZ
      {
        if( Kvalue < 0.01F )
        {
          Serial.print(" Error K incorect or negative");
          return;
        }
        int move_Z = (int)((pos_Z - Zvalue)* (float)driver_Z::STEP_PERMM);
        digitalWrite(driver_Z::DIRECTION, ( move_Z < 0 ) ^ ( driver_Z::FLIP == true ));
        
        //get spindle speed rpm
        int speed_in_rps = 0;
        bool last = false;
        unsigned long tim = millis();
        while( tim + 1000 >= millis())
        {
          if( !last )
          {
            if( digitalRead(spindle::SYNC) == HIGH )
            {
              speed_in_rps++;
              last =!last;
            }
          }
          else
          {
            if( digitalRead(spindle::SYNC) == LOW )
              last =!last;
          }
        }
        speed_in_rps/=spindle::SYNC_PULSES;
        if( speed_in_rps < 1 )
        {
          Serial.print(" Error speed to low or no sync pulses");
          return;
        }
        Fvalue = Kvalue*speed_in_rps*60;
        
        int pulses_per_sec_Z = (int)((Fvalue/60.0F)*(float)driver_Z::STEP_PERMM);
        counter2_target = abs(move_Z);
        cli();
        TCCR2B = (1<<WGM12) | (1<<CS22)| (1<<CS21); 
        TIMSK2 = (1<<OCIE1A);
        OCR2A = 31250/pulses_per_sec_Z;
        //sync with spindle
        while( digitalRead(spindle::INDEX) == LOW )
          delay(1);
        while( digitalRead(spindle::INDEX) == HIGH )
          delay(1);
        while( digitalRead(spindle::INDEX) == LOW )
          delay(1);
        
        sei();
        while( (counter1_target != 0) || (counter2_target != 0) )
          delay(1);
        pos_X = Xvalue;
        pos_Z = Zvalue;
        Serial.print(" ok");
      }
      if(( Gcode_num == 0 ) || ( Gcode_num == 1 ))//G0/G1 move XZ
      {
        int move_X = (int)((pos_X - Xvalue)* (float)driver_X::STEP_PERMM);
        int move_Z = (int)((pos_Z - Zvalue)* (float)driver_Z::STEP_PERMM);
        digitalWrite(driver_X::DIRECTION, ( move_X < 0 ) ^ ( driver_X::FLIP == true ));
        digitalWrite(driver_Z::DIRECTION, ( move_Z < 0 ) ^ ( driver_Z::FLIP == true ));
  
        int pulses_per_sec_X = (int)((Fvalue/60.0F)*(float)driver_X::STEP_PERMM);
        int pulses_per_sec_Z = (int)((Fvalue/60.0F)*(float)driver_Z::STEP_PERMM);
        //sychronization:
        float X_deest = fabsf((float)move_X)/(float)pulses_per_sec_X;
        float Z_deest = fabsf((float)move_Z)/(float)pulses_per_sec_Z;
        
        if(( fabs(move_X) >0.01F ) && ( fabs(move_Z) >0.01F  ) )
        {
          if( X_deest > Z_deest )
            pulses_per_sec_Z = (((float)pulses_per_sec_Z) / (X_deest/Z_deest));
          if( X_deest < Z_deest )
            pulses_per_sec_X = (((float)pulses_per_sec_X) / (Z_deest/X_deest));
        }
        
        counter1_target = abs(move_X);
        counter2_target = abs(move_Z);
        cli();
        TCCR1B = (1<<WGM12) | (1<<CS12); 
        TIMSK1 = (1<<OCIE1A);
        OCR1A = 31250/pulses_per_sec_X;
        TCCR2B = (1<<WGM12) | (1<<CS22)| (1<<CS21); 
        TIMSK2 = (1<<OCIE1A);
        OCR2A = 31250/pulses_per_sec_Z;
        sei();
        while( (counter1_target != 0) || (counter2_target != 0) )
          delay(1);
        pos_X = Xvalue;
        pos_Z = Zvalue;
        Serial.print(" ok");
      }
    }
    if( ( line.charAt(0) == '$' ) || ( line.charAt(1) == '$' ) )
    {
      //cofig stuff here
    }
    //else ignore comment or wathever
  }
}

float GetFloat(String str,int &pos)
{
  unsigned int str_length = str.length();
  float value = 0;
  bool point = false;
  float poin = 1;
  float sign = 1;
  for( ;pos < str_length; pos++)
  {
    unsigned int ch = str.charAt(pos);
    if(ch == '-' )
      sign = -1;
    if(ch == ' ' )
    {
      pos++;
      return value*sign;
    }
    if(ch == '.' )
        point = true;
    if((ch >= '0' ) && (ch <= '9' ))
      if( point )
      {
        poin*=10;
        value += (ch-'0')/poin;
      }
      else
      {
        value *= 10;
        value += (ch-'0');
      }
  }
  return value*sign;
}

//driver_X
bool onoff1 = false;
bool onoff2 = false;

ISR(TIMER1_COMPA_vect){
  if( onoff1 )
    digitalWrite(driver_X::STEP,HIGH);
  else
    digitalWrite(driver_X::STEP,LOW);
  if( onoff1 )
    counter1_target--;
  onoff1 = !onoff1;
  if( counter1_target <= 0 )
  {
    counter1_target = 0;
    TCCR1B = 0;
  }
  TCNT1  = 0;
}

//driver_Z
ISR(TIMER2_COMPA_vect){
  
  if( onoff2 )
    digitalWrite(driver_Z::STEP,HIGH);
  else
    digitalWrite(driver_Z::STEP,LOW);
  if( onoff2 )
    counter2_target--;
  onoff2 = !onoff2;
  if( counter2_target <= 0 )
  {
    counter2_target = 0;
    TCCR2B = 0;
  }
  TCNT2  = 0;
}
